;BLITZ3D SOURCE CODE
;BY "HOBO" BEN
;WWW.TOPHATSTUFF.CO.UK
;CODE, GFX AND AUDIO COPYRIGHT (C) 2006
;-----------------------------------------

AppTitle "Blitz'd Feet"
Graphics 640,480,0,2

Print "Loading..."

;Arrays
Dim DataLine$(250)

;Normal Globals
Global SinDegrees
Global XSin
Global YSin
Global SinImage
Global Heading=LoadFont("Arial",24,1,0,0)
Global Font=LoadFont("Arial",12,0,0,0)

;Scores...
Global Score_Perfect
Global Score_Great
Global Score_Good
Global Score_Ok
Global Score_Slow
Global Score_Missed
Global DataLineNo

;Sounds
Global Beat1=LoadSound("Audio\Drum1.wav")
Global Beat234=LoadSound("Audio\Drum234.wav")

Dim SFX(9)

SFX(1)=LoadSound("Audio\SynthDeep.wav")
SFX(2)=LoadSound("Audio\Clash.wav")
SFX(3)=LoadSound("Audio\SynthDeepEnd.wav")
SFX(4)=LoadSound("Audio\SynthMid.wav")
SFX(6)=LoadSound("Audio\SynthMidEnd.wav")
SFX(7)=LoadSound("Audio\SynthHigh.wav")
SFX(8)=LoadSound("Audio\Shaken.wav")
SFX(9)=LoadSound("Audio\SynthHighEnd.wav")


;Directional Images
Dim DirImage(9)
For DirLoader=1 To 9
	DirImage(DirLoader)=LoadImage("Gfx\D"+DirLoader+".bmp")
Next


CreateSinImage()

Cls
While Escape=False
	SetBuffer BackBuffer()
	Cls
	ResetSinGlobals()
	Menu()
	Play()
	ResetSinGlobals()
	DisplayScore()
	Escape=True
Wend
End










Function Play()

	;Read Data...
	EndOfData=False
	DataLineNo=1
	Composer$="Unknown"
	Name$="Unknown"
	LevelData=ReadFile("LevelData.txt")
	
;		Stop
	
		While Not EndOfData
			ReadData$=ReadLine$(LevelData)
			If ReadData$<>"" Then
				If Left$(ReadData$,1)<>"#" Then
					If Left$(ReadData$,1)<>"L" Then
						If ReadData$<>"END" Then 
							
							DataLine$(DataLineNo)=ReadData$
							DataLineNo=DataLineNo+1
							
						Else
							EndOfData=True
						EndIf
					Else
						If Left$(ReadData$,17)="LEVEL COMPOSER = " Then
							Composer$=Right$(ReadData$,(Len(ReadData$)-17))
						EndIf
						If Left$(ReadData$,13)="LEVEL NAME = " Then
							Name$=Right$(ReadData$,(Len(ReadData$)-13))
						EndIf
					EndIf
				EndIf
			Else
				EndOfData=True
			EndIf
		Wend
	
	DataLine$(DataLineNo)="STOP"
	CloseFile LevelData

	DataLineNo=1
	DataCharNo=1
	BeatNo=1
	Started=False
	EndOfData=False
	Opinion$=""
	
	Score_Perfect=0
	Score_Great=0
	Score_Good=0
	Score_Ok=0
	Score_Slow=0
	Score_Missed=0
	
	AppTitle ("Blitz'd feet - "+Name$)

	;Play...
	While Not EndOfData
		SetBuffer BackBuffer()
		Cls
		DrawImage SinImage,0,0
		Color(0,255,0)
		SetFont Font
		txt(20,20,"Composer: "+Composer$,0,0)
		txt(20,40,"Level Name: "+Name$,0,0)
		txt(20,60,"Bar: "+(((DataLineNo*4)+(DataCharNo-1))-4),0,0)
		SetFont Heading
		Color(155,255,155)
		txt(620,460,DataCharNo,1,1)
		
		Select Opinion$
			Case "Perfect!"
				Color(155,255,0)
				Score_Perfect=Score_Perfect+1
			Case "Great!"
				Color(255,155,100)
				Score_Great=Score_Great+1
			Case "Good"
				Color(255,75,75)
				Score_Good=Score_Good+1
			Case "Ok"
				Color(255,75,75)
				Score_Ok=Score_Ok+1
			Case "Slow!"
				Color(55,55,255)
				Score_Slow=Score_Slow+1
			Case "MISSED!"
				Color(255,0,0)
				Score_Missed=Score_Missed+1
		End Select
		
		txt2(320,100,Opinion$,1,1)
		;---
		
		
		If Started=True Then
			If BeatNo=1 Then
				ChannelBeat=PlaySound(Beat1)
			Else
				ChannelBeat=PlaySound(Beat234)		
			EndIf
		Else
			Started=True
		EndIf
			
		LineToActOn$=(DataLine$(DataLineNo))
		If LineToActOn$<>"STOP" Then
			CharToActOn=Int(Mid$(LineToActOn$,DataCharNo,1))
			DrawImage DirImage(CharToActOn),286,246
		Else
			EndOfData=True
		EndIf
		

		
	
		;---
		DataCharNo=DataCharNo+1
		If DataCharNo=5 Then
			DataCharNo=1
			DataLineNo=DataLineNo+1
		EndIf
		BeatNo=BeatNo+1
		If BeatNo=5 Then BeatNo=1

		Flip
		FlushKeys()

		Select CharToActOn
			Case 1
				KeyToHit=79
			Case 2
				KeyToHit=80
			Case 3
				KeyToHit=81
			Case 4
				KeyToHit=75
			Case 6
				KeyToHit=77
			Case 7
				KeyToHit=71
			Case 8
				KeyToHit=72
			Case 9
				KeyToHit=73
		End Select
		
		If CharToActOn<>5 Then
			Delay 75
			If KeyHit(KeyToHit) Then
				opinion$="Perfect!"
				ChannelSfx=PlaySound(SFX(CharToActOn))
				Delay 925
			Else
				Delay 125
				If KeyHit(KeyToHit) Then
					opinion$="Great!"
					ChannelSfx=PlaySound(SFX(CharToActOn))
					Delay 800
				Else
					Delay 250
					If KeyHit(KeyToHit) Then
						opinion$="Good"
						ChannelSfx=PlaySound(SFX(CharToActOn))
						Delay 550
					Else
						Delay 250
						If KeyHit(KeyToHit) Then
							opinion$="Ok"
							ChannelSfx=PlaySound(SFX(CharToActOn))
							Delay 300
						Else
							Delay 250
							If KeyHit(KeyToHit) Then
								opinion$="Slow!"
								ChannelSfx=PlaySound(SFX(CharToActOn))
								Delay 50 
							Else
								opinion$="MISSED!"
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Else
			Delay 1000
			opinion$=""
		EndIf
	Wend
End Function













Function Menu()
	AppTitle "Blitz'd Feet - Menu"
	MenuMusic=PlayMusic("Audio\Blitz-ed Feet.mp3")
	While Not KeyHit(28)
		SetBuffer BackBuffer()
		Cls
		
		DrawImage SinImage,0,0
		PlotSine(200,0,255,0)
		PlotSine(50,0,255,0)

		Color(0,255,0)
		SetFont Heading
		txt(320,120,"Blitz'd Feet",1,1)
		
		SetFont Font
		Color(0,255,0)		
		txt(320,140,"Press Return/Enter To Play!",1,1)
		
		Color(255,255,255)
		txt(20,160,"Welcome to HoboBen's 'Blitz'd Feet' game.",0,0)
		
		Color(200,255,200)
		txt(20,200,"Use the number pad on the right of your",0,0)
		txt(20,220,"keyboard to play. If you have any problems,",0,0)
		txt(20,240,"try messing with the 'Num Lock' key.",0,0)

		txt(20,280,"The objective of this game is to hit the",0,0)
		txt(20,300,"correct key on the beat.",0,0)

		txt(20,340,"You can open up the LevelData.txt file and",0,0)
		txt(20,360,"create your own levels!",0,0)

		Color(100,100,100)
		txt(2,2,"Copyright (C) TopHat Stuff 2006 - www.tophatstuff.co.uk",0,0)
		
		Flip
	Wend
	StopChannel MenuMusic
	FlushKeys()
End Function



Function DisplayScore()
	FlushKeys()
	ExitTrue=False
	AppTitle "Blitz'd Feet - Your Score"
	While Not KeyHit(28)
		SetBuffer BackBuffer()
		Cls
		
		DrawImage SinImage,0,0
		PlotSine(200,0,255,0)
		PlotSine(50,0,255,0)

		Color(0,255,0)
		SetFont Heading
		txt(320,120,"Blitz'd Feet",1,1)
		
		SetFont Font
		Color(255,255,0)		
		txt(320,140,"Your Score:",1,1)
		
		Color(155,255,0)
		txt(20,160,"Perfect:   "+Score_Perfect,0,0)
		
		Color(255,155,100)
		txt(20,180,"Great:   "+Score_Great,0,0)
		
		Color(255,75,75)
		txt(20,200,"Good:   "+Score_Good,0,0)
		
		Color(255,75,75)
		txt(20,220,"OK:   "+Score_Ok,0,0)
		
		Color(55,55,255)
		txt(20,240,"Slow:   "+Score_Slow,0,0)
		
		Color(255,0,0)
		txt(20,260,"Missed:   "+Score_Missed,0,0)
		
		Color(200,255,200)
		txt(320,160,"For comparative purposes, your total score is:",0,0)
		
		TotalScore#=(Score_Perfect*16)+(Score_Great*8)+(Score_Good*4)+(Score_Ok*2)+(Score_Slow*1)
		TotalScore#=TotalScore#/(DataLineNo*4*16)
		TotalScore#=TotalScore#*100
		TotalScoreInt=Int(TotalScore#)
		
		SetFont heading
		Color(255,255,0)
		txt(360,200,TotalScoreInt+"%",1,1)
		
		
		SetFont font
		txt(360,240,"And you played through "+((DataLineNo-1)*4)+" bars of music.",1,1)
		
		Color(255,255,0)
		txt(320,300,"Thanks for playing!",0,0)
		txt(320,320,"Press Return/Enter to quit.",0,0)

		Flip
	Wend	
	


End Function



Function PlotSine(SinAmp,SinRed,SinGreen,SinBlue)
	SinDegrees=SinDegrees+1
	If SinDegrees=360 Then SinDegrees=0
	XSin=Xsin+1
	If XSin>640 Then
		XSin=0
		SinDegrees=0
	EndIf
	YSin=240+((Sin#(SinDegrees)*SinAmp))
	Color(SinRed,SinGreen,SinBlue)
	Plot Xsin, Ysin
End Function



Function CreateSinImage()
	ResetSinGlobals()
	SinImage=CreateImage(640,480)
	SetBuffer ImageBuffer(SinImage)
		For PlottingImage=0 To 639
			PlotSine(200,0,88,0)
			PlotSine(50,0,88,0)
		Next
	SetBuffer FrontBuffer()
	ResetSinGlobals()
End Function



Function ResetSinGlobals()
	SinDegrees=0
	XSin=0
	YSin=0
End Function

Function txt(xpos,ypos,tex$,cenx,ceny)
	Local red=ColorRed()
	Local green=ColorGreen()
	Local blue=ColorBlue()
	Color 1,80,1
	Text xpos-1,ypos-1,tex$,cenx,ceny
	Text xpos-0,ypos-1,tex$,cenx,ceny
	Text xpos+1,ypos-1,tex$,cenx,ceny
	Text xpos-1,ypos+0,tex$,cenx,ceny
	Text xpos+1,ypos+0,tex$,cenx,ceny
	Text xpos-1,ypos+1,tex$,cenx,ceny
	Text xpos-0,ypos+1,tex$,cenx,ceny
	Text xpos+1,ypos+1,tex$,cenx,ceny
	Color (red,green,blue)
	Text xpos,ypos,tex$,cenx,ceny
End Function

Function txt2(xpos,ypos,tex$,cenx,ceny)
	Local red=ColorRed()
	Local green=ColorGreen()
	Local blue=ColorBlue()
	Color 255,255,255
	Text xpos-1,ypos-1,tex$,cenx,ceny
	Text xpos-0,ypos-1,tex$,cenx,ceny
	Text xpos+1,ypos-1,tex$,cenx,ceny
	Text xpos-1,ypos+0,tex$,cenx,ceny
	Text xpos+1,ypos+0,tex$,cenx,ceny
	Text xpos-1,ypos+1,tex$,cenx,ceny
	Text xpos-0,ypos+1,tex$,cenx,ceny
	Text xpos+1,ypos+1,tex$,cenx,ceny
	Color (red,green,blue)
	Text xpos,ypos,tex$,cenx,ceny
End Function